package top.ninwoo.utils.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import top.ninwoo.utils.service.TcService;
import top.ninwoo.utils.util.DockerUtils;
import top.ninwoo.utils.util.TcUtils;

import java.io.*;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @Author joliu
 * @Description
 * @Date　Create in 下午3:34 2019/11/1
 */
@Service
public class TcServiceImpl implements TcService {
    // 这里需要设计成有状态的
    private ConcurrentHashMap<String, Integer> qosMap = new ConcurrentHashMap<>();

    @Autowired
    TcUtils tcUtils;

    @Autowired
    DockerUtils dockerUtils;

    @Override
    public boolean addQos(String containerId, String maxRate, String latency) {
        // 添加到map中
        qosMap.put(containerId, Integer.parseInt(maxRate.substring(0, maxRate.length() - 4)));
        return tcUtils.addQos(containerId, maxRate, latency);
    }

    @Override
    public boolean delQos(String containerId) {
        return tcUtils.delQos(containerId);
    }

    @Override
    public float networkUsage(String containerId) {
        // TODO: TOTALBAND需要根据具体情况进行设置
        System.out.println("开始收集带宽率");
        float netUsage = 0.0f;
        String command = "cat /proc/net/dev";
        //第一次采集流量数据
        long startTime = System.currentTimeMillis();
        String[] lines = dockerUtils.execInDocker(containerId, command.split(" ")).split("\n");
        int i = 0;
        long inSize1 = 0, outSize1 = 0;
        while(i < lines.length){
            String line = lines[i++];
            line = line.trim();
            if(line.startsWith("eth1")){

                System.out.println(line);
                String[] temp = line.split("\\s+");
                //System.out.println("temp: "+temp.length+"temp[0]="+temp[0]);
                //这里可能因为不同操作系统 展示的结果不同，导致下标不同，
                //自己对照 cat /proc/net/dev 该指令执行后展示出的结构 找到Receive bytes 是数组里第几个元素，替换下标即可
                inSize1 = Long.parseLong(temp[1]); //Receive bytes,单位为Byte
                outSize1 = Long.parseLong(temp[9]);             //Transmit bytes,单位为Byte
                break;
            }
        }
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            StringWriter sw = new StringWriter();
            e.printStackTrace(new PrintWriter(sw));
            System.out.println("NetUsage休眠时发生InterruptedException. " + e.getMessage());
            System.out.println(sw.toString());
        }
        //第二次采集流量数据
        long endTime = System.currentTimeMillis();
        lines = dockerUtils.execInDocker(containerId, command.split(" ")).split("\n");
        i = 0;
        long inSize2 = 0 ,outSize2 = 0;
        while(i < lines.length){
            String line = lines[i++];
            line = line.trim();
            if(line.startsWith("eth1")){

                //System.out.println(line);
                String[] temp = line.split("\\s+");
                //这里数组下标也需要修改
                inSize2 = Long.parseLong(temp[1]);
                outSize2 = Long.parseLong(temp[9]);
                break;
            }
        }
        if(inSize1 != 0 && outSize1 !=0 && inSize2 != 0 && outSize2 !=0){
            float interval = (float)(endTime - startTime)/1000;
            //网口传输速度,单位为bps
            float curRate = (float)(inSize2 - inSize1 + outSize2 - outSize1)*8/(1000000*interval);
            int maxRate = 1000;
            if(qosMap.containsKey(containerId)) {
                maxRate = qosMap.get(containerId);
            }
            netUsage = curRate/maxRate;
            //System.out.println("本节点网口速度为: " + curRate + "Mbps");
            //System.out.println("本节点网络带宽使用率为: " + netUsage);

        }
        return netUsage;
    }
}
